try {

    var js = window.js = {};
    var highlighter;
    var searchResultApplier;
    var _currentSeclectedElement;
    var _currentScreenY;
    var _isMoved;
    var _currentTextJQObjects;
    
    var JY_COLOR_GREEN      = "green";
    var JY_COLOR_BLUE       = "blue";
    var JY_COLOR_ORANGE     = "orange";
    var JY_COLOR_PURPLE     = "purple";
    var JY_COLOR_UNDERLINE  = "underline";
    
    var JY_COLOR_CLASS_GREEN        = "jy_reader_green";
    var JY_COLOR_CLASS_BLUE         = "jy_reader_blue";
    var JY_COLOR_CLASS_ORANGE       = "jy_reader_orange";
    var JY_COLOR_CLASS_PURPLE       = "jy_reader_purple";
    var JY_COLOR_CLASS_UNDERLINE    = "jy_reader_underline";
    
    var JY_COLOR_CLASS_SEARCH       = "jy_search_highlight";
    
    var JY_NOTE_TYPE_HIGHLITE   = "highlight";
    var JY_NOTE_TYPE_NOTE       = "note";
    //    var JY_NOTE_TYPE_IMAGE      = "image";
    //    var JY_NOTE_TYPE_AUDIO      = "audio";


    /** ********************** 初始化 ********************************** */

    $(document).ready(function() { init(); });

    function init() {

        initRangy();

        //触摸拖动开始
        document.addEventListener("touchstart", touchStart, false);
        //触摸拖动进行中
        document.addEventListener("touchmove", touchMove, false);
        //触摸拖动结束
        document.addEventListener("touchend", touchEnd, false);

        // 给画廊添加点击事件
        $("div[data-widget-type='jy_gallery']").each(function(index) {
              // 画廊xml文件path
        	  var xmlPath = $(this).attr("data-widget-file");
        	  // 是否有点击事件flag
        	  var hasAction = $(this).attr("data-widget-action");
        	  // 画廊id
        	  var id = $(this).attr("data-widget-id");
        	  // 给当前画廊下面的img标签加上onclick事件
        	  $("div[data-widget-id='" + id + "'] img").each(function(position) {
        	      $(this).bind("click", function(){
        	          window.JieYueAndroid.ShowGroupImage(xmlPath, id, position - 1);
        	      });
        	  });
        });

        // 给从设计器里添加的图片加上点击查看大图事件
        $("div[data-widget-type='jy_image']").each(function(index){
            // 图片文件path
            var imagePath = $(this).attr("data-widget-file");
            // 是否有点击事件flag
            var hasAction = $(this).attr("data-widget-action");
            // 图片id
            var id = $(this).attr("data-widget-id");
            // 加上onclick事件
            $("div[data-widget-id='" + id + "'] img").bind("click", function(){
                window.JieYueAndroid.ShowBigImage(imagePath, id);
            });
        });

        // 给其他图片加上点击查看大图事件
        $("img").each(function(index){

            // 判断img标签上是否已经有点击事件,如果已经有click事件了，则不需要处理
            if (hasOnClickEvent($(this))) {
                return;
            }
            // 获取图片路径
            var path = $(this).attr("path");
            var alt = $(this).attr("alt");
            if (alt != "cover") {
                $(this).bind("click", function() {
                            window.JieYueAndroid.ShowBigImage(path, "");
                        });
            }


        });

        $("a").each(function(index){

            // 判断a标签上是否已经有点击事件, 如果已经有click事件了，则不需要处理
            if (hasOnClickEvent($(this))) {
                return;
            }

            // 通过JDesigner设计器添加的a标签处理
            // 获取标签上的data-type
            var dataType = $(this).attr("data-type");
            var dataTarget = $(this).attr("data-target");
            var dataId = $(this).attr("data-id");
            var dataControls = $(this).attr("data-controls");
            if (!dataControls) {
                dataControls = false;
            }
            // 如果dataType 不为undefuned
            if (dataType && dataTarget) {
                if (dataId === 'undefined') {
                    dataId = "";
                }

                $(this).attr("href", "javascript:void(0);");
                // 绑定点击事件
                $(this).bind("click", function(event){
                    if (navigator.userAgent.match(/Android/i)) { // android
                		window.JieYueAndroid.openLink(dataType, dataTarget, dataId, dataControls);
                		event.stopPropagation();
                	} else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
                		window.location.href = "openLink://linktType="
                				+ encodeURIComponent(linktType) + "&linkSource="
                				+ encodeURIComponent(linkSource) + "&showPlayer=" + isShow
                				+ "&name=" + encodeURIComponent(aName) + "&desc=" + aDesc;
                		event.stopPropagation();
                	} else {// pc

                	}
                });
                return;
            }

            // 不是通过JDesigner设计器添加的处理
            // 获取href是不是html结尾
            var href = $(this).attr("href");
            if (href != undefined && href != '') {
                var hrefArr = href.split("#");
                var lowerHref = href.toLowerCase();
                if (lowerHref.endsWith(".mp3")) {
                    bindLinkClick(this, "audio", href, "",dataControls);
                } else if (lowerHref.endsWith(".mp4")) {
                    bindLinkClick(this, "video", href, "", false);
                } else if (lowerHref.endsWith(".txt")) {
                    bindLinkClick(this, "txt", href, "",false);
                } else if (lowerHref.endsWith("jpg") || lowerHref.endsWith("jpeg") || lowerHref.endsWith("png")) {
                    bindLinkClick(this, "image", href, false);
                }else if (hrefArr && (hrefArr[0].endsWith(".html") || hrefArr[0].endsWith(".htm")
                    || hrefArr[0].endsWith(".shtm") || hrefArr[0].endsWith(".shtml")
                    || hrefArr[0].endsWith(".xml") || hrefArr[0].endsWith(".xhtml")
                    || hrefArr[0].endsWith(".dhtml") || hrefArr[0].startsWith("http"))) {
                    var id = '';
                    if (hrefArr.length > 1) {
                        id = hrefArr[1];
                    }
                    bindLinkClick(this, "html", href, id, false);
                }
            } else {
                $(this).attr("href", "javascript:void(0);");
            }

        });

        $("video").each(function(index) {

            var poster = $(this).attr("poster");
            if (!poster || poster === '') {
                $(this).attr("poster", "file:///android_asset/video_default.png");
            }

            var controls = $(this).attr("controls");
            if (!controls || controls === '') {
                $(this).attr("controls", "controls");
            }

            var playsinline = $(this).attr("webkit-playsinline");
            if (!playsinline || playsinline === '') {
                $(this).attr("webkit-playsinline", "true");
            }

            if (navigator.userAgent.match(/Android/i)) {
                var src = $(this).attr("src");
                $(this).bind('webkitbeginfullscreen', function(e) {
                    //window.JieYueAndroid.openVideo(src);
                });
            }

        });

        $("video").each(function(index) {
                $(this).bind("playing", videoStarted);
                $(this).bind("pause", videoStoped);
         });
        
        $("audio").each(function(index) {
                $(this).bind("playing", audioStarted);
                $(this).bind("pause", audioStoped);
        });
        
        //初始化页面行间距
        $("body p").css("line-height", js_readingLineHeight);
        //初始化背景色
        $("body").css("background", js_readingBgColor);
        $("body").css("zoom", js_readingFont);
	    rePositionNoteIcon();
	
        if (js_readingBgColor == '#283448') {
            $("body p").css("color", '#ECECEC');
        } else {
            $("body p").css("color", '#000000');
        }
    }

    var highlighterSetting = {
        ignoreWhiteSpace : true,
        elementTagName : "span",
        elementProperties : {
            onclick : function() {
                _currentSeclectedElement = this;
                var uuid = $(this).attr("uuid");
                var type = $(this).attr("type");
                var color = $(this).attr("color");
                showEditHighlightMenu(uuid, type, color);
                return false;
            }
        }
    };

	function initRangy() {
		rangy.init();
        
		highlighter = rangy.createHighlighter();
		highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_BLUE, highlighterSetting));
		highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_GREEN, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_ORANGE, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_PURPLE, highlighterSetting));
        highlighter.addClassApplier(rangy.createCssClassApplier(JY_COLOR_CLASS_UNDERLINE, highlighterSetting));
        searchResultApplier = rangy.createClassApplier(JY_COLOR_CLASS_SEARCH);
	}

	function touchStart(event) {
        _isMoved = false;
    }
    
    function touchMove(event) {
        _isMoved = true;
    }
    
    function touchEnd(event) {
        var targetName = event.target.tagName.toLowerCase();

        // 如果是video标签，也不对titlebar做操作
        if (targetName && targetName == "video") {
            return;
        }

        // 如果是a标签，也不对titlebar做操作
        if (targetName && targetName == "a") {
            return;
        }

        var uuid = $(event.target).attr("uuid");
        var isNoteElement = uuid && uuid != 'undefined' && uuid.length > 0;
        //有onclick事件的，响应对应事件, 或者点击的是笔记也显示笔记编辑菜单
        if (isNoteElement || hasOnClickEvent($(event.target))) {
            return;
        }
        
        //隐藏高亮笔记对应的菜单
        if (js.contextMenuDidShown) {
            js.contextMenuDidShown=false;
            return;
        }
//        var touch = event.changedTouches[0] || event.targetTouches[0] || null;
        var selection = window.getSelection();
        //长按选择文字后显示高亮笔记对应的菜单
        if (selection && selection.toString() != '') {
            return;
        }
        
        if (!_isMoved) {
            if (js.topBottomBarShown) {
                window.JieYueAndroid.hideTopAndBottomBar();
                return;
            } else {
                window.JieYueAndroid.showTopAndBottomBar();
                return;
            }
        }
    }

    /**
     *  判断标签上是否有click事件或监听
     */
     function hasOnClickEvent(obj) {
         // 判断原本标签上有没有 onClick
         var onClickFunction = obj.attr("onClick");
         var haveOnClickEvent = onClickFunction && onClickFunction != 'undefined' && onClickFunction != '';
         // 判断标签上有没有绑定了click监听
         var bindObj = $._data(obj[0],"events");
         var hasBind = bindObj && bindObj["click"];

         return (hasBind || haveOnClickEvent);
     }

     /**
      *  给a标签加上click监听并且把href设置成javascript:void(0);
      */
     function bindLinkClick(targetObj, type, target, id, isShowPlayer) {
        $(targetObj).attr("href", "javascript:void(0);");
        $(targetObj).attr("data-target", target);
        $(targetObj).bind("click", function(){
             window.JieYueAndroid.openLink(type, target, id, isShowPlayer);
        });
     }

	/**
	 * ********************************* 控件事件相关 ******************************************
	 */

	 //后面这几个都是统计要用的
    function videoStarted(event) {//注意一个页面内可能同时打开多个视频，音频
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.videoStarted(fullPath);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://videoStarted?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function videoStoped(event) {
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name="";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc="";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.videoStoped(fullPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://videoStoped?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function audioStarted(event) {//注意一个页面内可能同时打开多个视频，音频
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name="";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc="";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.audioStarted(fullPath);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://audioStarted?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }
    
    function audioStoped(event) {
        var fullPath = $(event.target).attr("src");
        if (fullPath === undefined) {
            return;
        }
        
        var name = $(event.target).attr("name");
        if (name === undefined) {
            name = "";
        }
        
        var desc = $(event.target).attr("desc");
        if (desc === undefined) {
            desc = "";
        }
        
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.audioStoped(fullPath, name, desc);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://audioStoped?fullPath=" + encodeURIComponent(fullPath);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    //替换showNoteToUpdate，用来显示已有高亮或笔记时候的弹窗
    function showEditHighlightMenu(uuid, type, color) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showEditHighlightMenu(uuid, type, color);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showEditHighlightMenu?uuid=" + encodeURIComponent(uuid) +
                                                                     "&type=" + encodeURIComponent(type) +
                                                                     "&color=" + encodeURIComponent(color);
            event.stopPropagation();
        } else {// pc
            
        }
    }

    function showNoteToUpdate(event, uuid) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.showNoteToUpdate(uuid);
            event.stopPropagation();
        } else if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {// ios
            window.location.href = "jycommand://showNoteToUpdate?uuid="
                + encodeURIComponent(uuid);
            event.stopPropagation();
        } else {// pc

        }
    }

    /** ******************************************************************* */

	/*
	 * clear selection
	 */
	function clearCurrentSelection() {
        if (window.getSelection) {
             if (window.getSelection().removeAllRanges) {  // Firefox
                window.getSelection().removeAllRanges();
             } else if (window.getSelection().empty) {  // Chrome
                 window.getSelection().empty();
            }
    } else if (document.selection) { // IE?
            document.selection.empty();
        }
    }

    /*
     * note current selection
     * 高亮接口, android系统6.0以下调用该方法
     */
    function highlight(uuid, type, color) {
        var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
        createNewHighlight(uuid, type, colorType);

        if (navigator.userAgent.match(/Android/i)) { // android
            window.JieYueAndroid.setSerializeSelection(uuid,android.serializeSelection);
        }
    }

    /*
     * note current selection
     * 高亮接口, android系统6.0以上调用该方法
     */
     function highlightAfterM(uuid, type, color) {
         var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
         createNewHighlight(uuid, type, colorType);
     }

    /*
     * 获取选中的文字
     */
    function getSelectionText(event) {
        if (navigator.userAgent.match(/Android/i)) { // android
            window.getSelectAndroid.getSelectText(event, window.getSelection().toString(), android.selection.getRange());
        }
    }

    /*
     * create new hightlight color
     * 不用管
     */
    function createNewHighlight(uuid, type, color) {
        if (color === JY_COLOR_GREEN) {
            highlighter.highlightSelection(JY_COLOR_CLASS_GREEN);
        } else if (color === JY_COLOR_BLUE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_BLUE);
        } else if (color === JY_COLOR_ORANGE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_ORANGE);
        } else if (color === JY_COLOR_PURPLE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_PURPLE);
        } else if (color === JY_COLOR_UNDERLINE) {
            highlighter.highlightSelection(JY_COLOR_CLASS_UNDERLINE);
        }
    
        var length = highlighter.highlights.length;
        if (length > 0) {
            var highlight = highlighter.highlights[length - 1];
            var eleArray = highlight.getHighlightElements();
            for (var i = 0; i < eleArray.length; i++) {
                var el = eleArray[i];
                if (i == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    //$(el).addClass("jy_note_sub_icon_cls");
                    addNoteIcon(uuid, el);
                }
                _currentSeclectedElement = el;
                if (uuid != undefined && uuid != null) {
                    $(el).attr("uuid", uuid);
                }
                if (type != undefined && type != null) {
                    $(el).attr("type", type);
                }
                if (color != undefined && color != null) {
                    $(el).attr("color", color);
                }
            }
        }
    }

    /*
     * update current Highlight
     * 用于换颜色，把高亮变笔记用
     */
    function updateCurrentHighlight(uuid, type, color) {
        var elColor = $(_currentSeclectedElement).attr("color");
        color = (color === undefined || color === null) ? elColor : color;
        
        var targetClassApplier;
        if (color === JY_COLOR_GREEN) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_GREEN];
        } else if (color === JY_COLOR_BLUE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_BLUE];
        } else if (color === JY_COLOR_ORANGE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_ORANGE];
        } else if (color === JY_COLOR_PURPLE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_PURPLE];
        } else if (color === JY_COLOR_UNDERLINE) {
            targetClassApplier = highlighter.classAppliers[JY_COLOR_CLASS_UNDERLINE];
        }
        
        var highlight = highlighter.getHighlightForElement(_currentSeclectedElement);
        if (highlight != undefined && highlight != null) {
            highlight.unapply();
            highlight.classApplier = targetClassApplier;
            highlight.apply();
            
            var eleArray = highlight.getHighlightElements();
            for (var i = 0; i < eleArray.length; i++) {
                var el = eleArray[i];
                if (i == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    //$(el).addClass("jy_note_sub_icon_cls");
                    addNoteIcon(uuid, el);
                }
                
                if (uuid != undefined && uuid != null) {
                    $(el).attr("uuid", uuid);
                }
                if (type != undefined && type != null) {
                    $(el).attr("type", type);
                }
                if (color != undefined && color != null) {
                    $(el).attr("color", color);
                }
            }
        }
    }

    /*
	 * remove current select highlight
     * 删除某个笔记的时候用
	 */
	function removeCurrentSelectedHighlight() {
        var highlight = highlighter.getHighlightForElement(_currentSeclectedElement);
        var eleArray = highlight.getHighlightElements();
        for (var i = 0; i < eleArray.length; i++) {
            var el = eleArray[i];
            //$(el).removeClass("jy_note_sub_icon_cls");
            var uuid = $(el).attr("uuid");
            $("div[uuid='" + uuid + "']").remove();
            $(el).removeAttr("uuid");
            $(el).removeAttr("type");
            $(el).removeAttr("color");
            $(el).removeAttr("onClick");
        }
		//highlighter.unhighlightSelection();
        highlighter.removeHighlights([highlight]);
    }

    /**
	 * restore Notes
     * 在加载完webview数据后还原本页笔记
	 */
	function restoreNotes(uuid, type, color, serializeSelection) {
        var colorType = (color === undefined || color === null) ? JY_COLOR_GREEN : color;
		rangy.deserializeSelection(serializeSelection);
		createNewHighlight(uuid, type, colorType);
		
		if (navigator.userAgent.match(/Android/i)) { // android
			android.selection.clearSelection();
		}
        
        clearCurrentSelection();
	}

	//共享笔记用，点击某人笔记，先removeAllHighlightsOnThisPage，然后调restoreNotes还原某人笔记
    function removeAllHighlightsOnThisPage() {
        for (var i = 0; i < highlighter.highlights.length; i++) {
            var highlight = highlighter.highlights[i];
            var eleArray = highlight.getHighlightElements();
            for (var j = 0; j < eleArray.length; j++) {
                var el = eleArray[j];
                //$(el).removeClass("jy_note_sub_icon_cls");
                var uuid = $(el).attr("uuid");
                $("div[uuid='" + uuid + "']").remove();
                
                $(el).removeAttr("uuid");
                $(el).removeAttr("type");
                $(el).removeAttr("color");
                $(el).removeAttr("onClick");
            }
        }
        highlighter.removeAllHighlights();
    }

	function removeAllCurrentSearchHighlight() {
        var searchRange = rangy.createRange();
        searchRange.selectNodeContents(document.body);
        searchResultApplier.undoToRange(searchRange);
	}

//    function scrollToBottom() {
//        var height = $(document).height();
//        window.scroll(0, height);
//    }
	
	function scrollToHighlightByUUID(uuid) {
        var noteLoationElement = $("span[uuid='" + uuid + "']:first")[0];
        if  (noteLoationElement && noteLoationElement != "undefined") {
            var offsetVal = $(noteLoationElement).offset();
            window.scroll(0, offsetVal.top-60);
        }
    }

    function scrollToElementById(elementId) {
        var hashElement = document.getElementById(elementId);
        if(hashElement) {
            hashElement.scrollIntoView();
        }
    }
	
	function doSearch(searchString) {
        if (searchString !== "") {
            var searchRange = rangy.createRange();
            searchRange.selectNodeContents(document.body);
            searchResultApplier.undoToRange(searchRange);
            
            var searchScopeRange = rangy.createRange();
            searchScopeRange.selectNodeContents(document.body);
            var options = {
                caseSensitive: false,
                wholeWordsOnly: false,
                withinRange: searchScopeRange,
                direction: "forward"
            };
        
            while (searchRange.findText(searchString, options)) {
                searchResultApplier.applyToRange(searchRange);
                searchRange.collapse(false);
            }

            var elements = $("."+JY_COLOR_CLASS_SEARCH);
            for (var j = 0; j < elements.length; j++) {
                var el = elements[j];
                $(el).attr("id", "SID-"+j);
            }
        }
    }

    /*
     * add note icon for current selection at an Y position
     */
    function addNoteIcon(uuid, noteObj) {
        if	(noteObj && noteObj != "undefined") {
            var el = $('<i/>').css('display','inline').insertAfter(noteObj);
            var pos = el.offset();//el[0].getBoundingClientRect();
            el.remove();
            
            var noteImage = document.createElement("div");
            noteImage.className = "jy_note_icon_cls";
            noteImage.style.left = pos.left - 10;
            noteImage.style.top = pos.top + 10;
            
            
            $(noteImage).attr("uuid", uuid);
            $(noteImage).attr("onClick", "showNoteToUpdate(event, '" + uuid + "')");
            //$(noteImage).appendTo("#cf_book_content_div");
             $(document.body).append(noteImage);
        }
    }
    
    function rePositionNoteIcon() {
        for (var i = 0; i < highlighter.highlights.length; i++) {
            var highlight = highlighter.highlights[i];
            var eleArray = highlight.getHighlightElements();
            for (var j = 0; j < eleArray.length; j++) {
                var el = eleArray[j];
                var uuid = $(el).attr("uuid");
                var type = $(el).attr("type");
                
                if (j == (eleArray.length - 1) && type == JY_NOTE_TYPE_NOTE) {
                    var tempEL = $('<i/>').css('display','inline').insertAfter(el);
                    var pos = tempEL.offset();
                    tempEL.remove();
                    $("div[uuid='" + uuid + "']:first").offset({left:pos.left - 10, top:pos.top + 10});
                }
            }
        }
    }

	function setFontSizeClass(fontSize) {
        var size = '80%';
        if (fontSize == 1) {
            size = '50%';
        } else if (fontSize == 2) {
            size = '60%';
        } else if (fontSize == 3) {
            size = '70%';
        } else if (fontSize == 4) {
            size = '80%';
        } else if (fontSize == 5) {
            size = '90%';
        } else if (fontSize == 6) {
            size = '110%';
        } else if (fontSize == 7) {
            size = '120%';
        }
        //document.getElementsByTagName('body')[0].style.webkitTextSizeAdjust = size;
        
        $("body").css("zoom", size);
        rePositionNoteIcon();
	}

	function setBase64Img(imgId, base64Str) {
		var img = document.getElementById(imgId);
		img.src = base64Str;
	}

	function pauseAllVideo() {
		var videos = document.querySelectorAll("video");
		for ( var i = videos.length - 1; i >= 0; i--) {
			videos[i].pause();
		}
	}

	function pauseVideoWithoutPath(path) {
    	var videos = document.querySelectorAll("video");
    	for ( var i = videos.length - 1; i >= 0; i--) {
    	    var src = $(videos[i]).attr("src");
    	    if ((src != undefined && src != null) && src.indexOf(path) == -1) {
    	    	videos[i].pause();
    	    }
    	}
    }

    function setLineHightClass(szie) {
        var lineHeight = '160%';
        if (szie == 1) {
            lineHeight = '200%';
        } else if (szie == 2) {
            lineHeight = '160%';
        } else if (szie == 3) {
            lineHeight = '120%';
        }
        
        $("body p").css("line-height", lineHeight);
        rePositionNoteIcon();
    }
    
    function setReadingBgClass(stringColor) {
        $("#jy_night_stylesheet").remove();
        $("body").css("background", stringColor);
        if (stringColor === '#283448') {
            $("body").css("color", '#ECECEC');
        } else {
            $("body").css("color", '#000000');
        }
    }
    
    function changeToNightMode(useNightMode) {
        if (useNightMode === "1") {
            $("<link>").attr({id:"jy_night_stylesheet", rel:"stylesheet", type:"text/css", href:"file:///android_asset/night.css"}).appendTo("head");
        } else {
            $("#jy_night_stylesheet").remove();
        }
    }
    
    function changeToProtectEyeMode(useProtectEyeMode) {
        if (useProtectEyeMode === "1") {
             $("<link>").attr({id:"jy_eye_stylesheet", rel:"stylesheet", type:"text/css", href:"file:///android_asset/eye.css"}).appendTo("head");
        } else {
             $("#jy_eye_stylesheet").remove();;
        }
    }
    
    /** ******************************************************************* */

	/*
	 * 讯飞语音阅读相关部分
	 */
    
    function ttsTextCount() {
        if (_currentTextJQObjects === undefined || _currentTextJQObjects === null) {
            _currentTextJQObjects = $("p, h1, h2, h3, h4, h5, h6");
        }
        window.JieYueAndroid.ttsTextCount(_currentTextJQObjects.length);
    }
    
    function highlightTTSTextAtIndex(index) {
        var lastIndex = index - 1;
        if (lastIndex >= 0) {
            var lastTextJQObj = _currentTextJQObjects[lastIndex];
            $(lastTextJQObj).removeClass("jy_voice_highlight_cls");
        }
        
        var textJQObj = _currentTextJQObjects[index];
        var targetText = $(textJQObj).text();
        if (targetText.length > 0) {
            $(textJQObj).addClass("jy_voice_highlight_cls");
        }
        $('html, body').animate({
                                scrollTop: $(textJQObj).offset().top - 20
                                }, 1000);
        window.JieYueAndroid.highlightTTSTextAtIndex(targetText);
    }
    
    function removeTTSTextHighlightAtIndex(index) {
        if (_currentTextJQObjects === undefined || _currentTextJQObjects === null || _currentTextJQObjects.length == 0) {
   		    return;
        }
        var textJQObj = _currentTextJQObjects[index];
        $(textJQObj).removeClass("jy_voice_highlight_cls");
    }

    function loadHash(hashName) {
        window.location.hash = hashName;
    }

} catch (error) {
	alert("JS error: " + error);
}